/**
 * JS Document.
 * @author Sandro Jordão.
 */

function gravarGrupo()
{
	$.post(basepath + 'principal/verificarLogado', 
		function(logado) {
			if(logado == 0)
			{
				// 
				var nome = $("#nomeGrupo").val();
				var sistema = $("input[name='rdoSistema']:radio:checked").val();
			
				var usersArray = new Array();
				$(".checkbox").each(function(){ usersArray.push($(this).val()); });

				$('.msgErro').remove();

				var erro = 0;

				if(nome == '')
				{
					$('#nomeGrupo').after("<span class='msgErro'> Campo de preenchimento obrigatório. </span>");
					erro++;
				}

				if (erro == 0)
				{
					$.post(basepath + "cadastros/gravaGrupo", {
						nome : nome,
						sistema : sistema,
						'usuarios[]' : usersArray
					}, function(data) {
						if(data == 1) {
							jAlert('Gravado com sucesso!', 'Alerta!', function() { window.location.href = basepath + 'cadastros/grupos'; });
						} else {
							jAlert('Ocorreu um erro:\n ' + data, 'Alerta!', function() { return false; });
						}
					});
				}
				else
				{
					jAlert('Favor preencher todos os campos corretamente.', 'Alerta!', function() { return false; });
				}
				//
			}
			else
			{
				window.location.href = basepath + 'principal/' + logado;
			}
		});
}

function alterarGrupoBD()
{
	$.post(basepath + 'principal/verificarLogado', 
		function(logado) {
			if(logado == 0)
			{
				// 
				var grupo = $("#txtGrupoID").val();
				var nome = $("#nomeGrupo").val();
				var usersArray = new Array();
				$(".checkbox").each(function(){ usersArray.push($(this).val()); });

				$('.msgErro').remove();

				var erro = 0;

				if(nome == '')
				{
					$('#nomeGrupo').after("<span class='msgErro'>Campo de preenchimento obrigatório.</span>");
					erro++;
				}

				if (erro == 0)
				{
					$.post(basepath + "cadastros/alterarGrupoBD", {
						nome  : nome,
						grupo : grupo,
						'usuarios[]' : usersArray
					}, function(data){
						if(data == 1) {
							jAlert('Grupo alterado com sucesso!', 'Alerta!', function() { window.location.href = basepath + 'cadastros/grupos'; });
						} else {
							jAlert('Ocorreu um erro:\n ' + data, 'Alerta!', function() { return false; });
						}
					});
				}
				else
				{
					jAlert('Favor preencher todos os campos corretamente.', 'Alerta!', function() { return false; });
				}
				//
			}
			else
			{
				window.location.href = basepath + 'principal/' + logado;
			}
		});
}

function incluir()
{
	window.location.href = basepath + 'cadastros/cadgrupo';
}

function alterar()
{
	var grupo = $('#gridGrupos').jqGrid('getGridParam','selrow');

    if(grupo) {
		window.location.href = basepath + 'cadastros/alterarGrupo/' + grupo;
	} else {
		jAlert('Selecionar um grupo para alteração!', 'Alerta!', function() { return false; });
	}
}

function excluir()
{
	var grupo = $('#gridGrupos').jqGrid('getGridParam','selrow');

    if(grupo)
	{
		var usuarioMaster = $('#usuarioMaster').val();
		var grupoSistema = $('#gridGrupos').getCell(grupo, 'SISTEMA');
		
		if(grupoSistema == 'S' && usuarioMaster == 'N')
		{
			jAlert('O grupo selecionado não pode ser excluido!', 'Alerta!', function() { return false; });
		}
		else
		{
			$.post(basepath + 'principal/verificarLogado', 
				function(logado) {
					if(logado == 0)
					{
						// 
						jConfirm("Deseja realmente excluir o grupo?", 'Confirmação!',
							function(r) {
								if (r == true)
								{
									$.post(basepath + "cadastros/excluirGrupo", {
										grupo  : grupo
									}, function(data){
										if(data == 1)
										{
											$("#gridGrupos").trigger("reloadGrid");
											
											jAlert('Grupo excluído com sucesso!', 'Alerta!');
										}
										else jAlert('Ocorreu um erro:\n ' + data, 'Alerta de erro!');
									});
								}
								else
								{
									return false;
								}
							});
							//
					} 
					else
					{
						window.location.href = basepath + 'principal/' + logado;
					}
				});
		}
	}
    else
	{
		jAlert('Selecionar um grupo para exclusão!', 'Alerta!', function() { return false; });
	}
}

function buscaGrupo()
{
	var grupoid = $("#comboGrupo").val();

	if(grupoid != '')
	{	
		$("#comboGrupo").after('<img src="' + basepath + 'www/imagem/loadingModal.gif" class="imgLoading" align="absmiddle" />');
		
		$.post(basepath + "cadastros/buscaDadosGrupo", {
			grupoid : grupoid
		}, function(data) {
			$("#nomeGrupo").val($('#comboGrupo option:selected').text());
			$(".usersList").html(data);
			$(".checkbox").click(desabilitaRemover);
			$(".imgLoading").remove();
		});
	}
	else
	{
		return false;
	}
}

function buscaDadosGrupo()
{
	var opcao = $('input[name=rdoGrupo]:radio:checked').val();
	
	if(opcao == 'E')
		$("#comboGrupo").removeAttr("disabled");
	else
	{
		$("#comboGrupo").attr("disabled", true).val("");
		$("#nomeGrupo").val("");
		$(".usersCheckbox, #user_all").removeAttr('checked');
	}
}

function adicionar()
{
	var users = new Array();
	var count = 0;
	
	$(".usersCheckbox:checked").each(function(){ 
		users.push($(this).val()); 
		count++; 
	});
	
	$(".checkbox").each(function(){ 
		users.push($(this).val()); 
		count++;
	});
	
	if(count > 0)
	{
		$.post(basepath + "cadastros/montarHtmlUsuarios", {
			"usuarios[]" : users
		}, function(data) {
			$(".usersList").html(data);
			$(".checkbox").click(desabilitaRemover);
			fechar();
		});
	}
	else
		fechar();
}

function checkUsers()
{
	var uChecked = $("#user_all").is(':checked');
	$(".usersCheckbox").attr('checked', uChecked);
}

function msn()
{
	if($('#procurarUsuario').val() == '')
	{
		$('#procurarUsuario').val('Pesquisar usuários...');
		$('#procurarUsuario').removeClass('inputProcurarOff').addClass('inputProcurarOn');
	}
}

function limpar()
{
	if($('#procurarUsuario').val() == 'Pesquisar usuários...')
	{
		$('#procurarUsuario').val('');
		$('#procurarUsuario').removeClass('inputProcurarOn').addClass('inputProcurarOff');
	}
}

function procurar()
{
	var valor = $.trim($("#procurarUsuario").val());
	
	if(valor == 'Pesquisar usuários...') valor = '';
	
	if(valor.length > 2 || valor == '')
	{
		$("#btn_procurar").hide();
		$("#loadingModal").show();

		$.post(basepath + "cadastros/procurarUsuarios", {
			valor : valor
		}, function(data) {
			$(".modalList").html(data);
			$(".checkbox").each(function(){ $("#user_" + this.id).parent().parent().remove(); });
			$("#loadingModal").hide();
			$("#btn_procurar").show();
		});
	}
}

function adicionarUsuario()
{
	$.post(basepath + "cadastros/adicionarUsuario", { }, function(data){
	
		$("#janela_modal").html('');
		$("#overlay").html('');
		
		var overlay = '<div id="overlay"></div>';
		var overlayCSS = {'width' : pageWidth + 'px','height' : pageHeight + 'px'};
		
		var janela = '<div id="janela_modal"></div>';
		var janelaCSS = {'top' : '50%','left' : '50%','width' : '500px','height' : '350px','margin-left' : '-250px','margin-top' : '-175px'};
		
		var btnFechar = '<a onClick="fechar()"><img id="btnFechar" src="' + basepath + 'www/imagem/close.png" alt="Fechar" title="Fechar" /></a>';
		var btnFecharCSS = {'position' : 'absolute','top' : '50%','left' : '50%','cursor' : 'pointer','margin-left' : '225px','margin-top' : '-180px'}
		
		var btnCancelar = '<input type="image" id="btn_cancelar" name="btn_cancelar" src="' + basepath + 'www/imagem/btn_cancelar.png" onClick="fechar()" />';
		var btnCancelaCSS = {'position' : 'absolute','top' : '100%','left' : '100%','margin-left' : '-115px','margin-top' : '-45px','width' : '100px'}
		
		var btnOK = '<input type="image" id="btn_enviar" name="btn_enviar" src="' + basepath + 'www/imagem/btn_ok.png" onClick="adicionar()" />';
		var btnOKCSS = {'position' : 'absolute','top' : '100%','left' : '0%','margin-left' : '300px','margin-top' : '-45px','width' : '100px'}
		
		$("body").append(overlay);
		$("body").append(janela);
		$("#overlay").css(overlayCSS).fadeIn('slow', function(){
			
			$("#janela_modal").append(data);
			
			$("#janela_modal").append(btnFechar);
			$("#btnFechar").css(btnFecharCSS).fadeIn("slow");
			
			$("#janela_modal").append(btnCancelar);
			$("#btn_cancelar").css(btnCancelaCSS);
			
			$("#janela_modal").append(btnOK);
			$("#btn_enviar").css(btnOKCSS);
			
			$("#janela_modal").css(janelaCSS).fadeIn("slow");
			
			$(".checkbox").each(function(){ $("#user_" + this.id).parent().parent().remove(); });
			
			$('#procurarUsuario').keyup(procurar);
		});
		
		return false;
	});
}

function fechar() 
{
    $("#janela_modal").fadeOut();
    $("#overlay").fadeOut();
}

function removerUsuario()
{
	$(".checkbox:checked").each(function(){
		$(this).parent().parent().remove();
	});
	
	desabilitaRemover();
}

function desabilitaRemover()
{
	var count = 0;
	$(".checkbox:checked").each(function(){ count++; });
	if(count == 0) 
		$("#btnRemover").attr("disabled", true); 
	else
		$("#btnRemover").removeAttr("disabled");
}

function gerarDashboard(id, tipo)
{
	jConfirm("Deseja realmente incluir o relatório no dashboard?", 'Confirmação!',
    function(r) {
        if (r == true)
        {
            $.post(basepath + "principal/inserirDashboard", {
                relatorio : id
            }, function(data) {
                if (data == 1)
                    window.location.href = basepath + 'principal/dashboard';
                else
                    jAlert('Não foi possível incluir o relatório!', 'Alerta!');
            });
        }
        else
        {
            return false;
        }
    });
}

function voltar()
{
	window.location.href = basepath + 'cadastros/grupos';
}

function init()
{
	pageWidth = $(window).width();
	pageHeight = $(window).height();
	
	$(".checkbox").click(desabilitaRemover);
	
	var count = 0;
	$("#comboGrupo option").each(function() { count++ });
	if(count < 2){
		$("#existeGrupo").attr("disabled", true);
		$("#comboGrupo, #lblExisteGrupo").css({'color' : '#999'});
	}
	
	var pathGrupo = basepath + "cadastros/grupos";
	$('#menuContentLeft a').each(function() {
		if(pathGrupo == $(this).attr("href")) {
			$(this).css({'color' : '#4084b8', 'font-weight' : 'bold', 'font-style' : 'italic'});
		}
	});
}

$(document).ready(init);